/* Problem URL: https://codeforces.com/gym/105327/problem/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vvi tree(n + m);

    vi dsu(n + m);
    rep(i, dsu.size()) {
        dsu[i] = i;
    }

    function<int(int)> find_p = [&](int i) {
        if (dsu[i] == i) {
            return i;
        }
        return dsu[i] = find_p(dsu[i]);
    };

    auto join = [&](int a, int b) {
        a = find_p(a);
        b = find_p(b);

        if (a == b) {
            return false;
        }

        dsu[a] = b;
        return true;
    };

    rep(i, n) {
        int k;
        cin >> k;

        while (k--) {
            int j;
            cin >> j;
            j--;

            if (!join(i, j + n)) {
                continue;
            }

            tree[i].push_back(j + n);
            tree[j + n].push_back(i);
        }
    }

    vvi parent(n + m, vi(25));
    vi depth(n + m, -1);
    vi group(n + m, -1);
    int g = 0;
    V<bool> vis(n + m);

    function<void(int, int)> buildlca = [&](int i, int p) {
        parent[i][0] = p;
        depth[i] = depth[p] + 1;
        group[i] = g;

        vis[i] = true;

        nrep(j, 1, 25) {
            parent[i][j] = parent[parent[i][j - 1]][j - 1];
        }

        for (auto j : tree[i]) {
            if (j == p) {
                continue;
            }

            buildlca(j, i);
        }
    };

    rep(i, n + m) {
        if (vis[i]) {
            continue;
        }

        buildlca(i, i);
        g++;
    }

    auto lca = [&](int a, int b) {
        if (depth[a] > depth[b]) {
            swap(a, b);
        }

        int diff = depth[b] - depth[a];

        rep(i, 25) {
            if ((diff >> i) & 1) {
                b = parent[b][i];
            }
        }

        if (a == b) {
            return a;
        }

        for (int i = 24; i >= 0; i--) {
            if (parent[a][i] == parent[b][i]) {
                continue;
            }

            a = parent[a][i];
            b = parent[b][i];
        }

        return parent[a][0];
    };

    int q;
    cin >> q;
    while (q--) {
        int a, b;
        cin >> a >> b;
        a--, b--;

        a += n;
        b += n;

        if (group[a] != group[b]) {
            cout << "-1\n";
            continue;
        }

        int p = lca(a, b);

        vi ans1;
        vi ans2;

        while (a != p) {
            ans1.push_back(a + 1);
            a = parent[a][0];
        }

        ans1.push_back(a + 1);

        while (b != p) {
            ans2.push_back(b + 1);
            b = parent[b][0];
        }

        reverse(all(ans2));

        cout << (ans1.size() + ans2.size() + 1) / 2 << '\n';

        repv(i, ans1) {
            cout << i - (i > n ? n : 0) << ' ';
        }

        repv(i, ans2) {
            cout << i - (i > n ? n : 0) << ' ';
        }
        cout << '\n';
    }
}
